#!/bin/sh
# Component: drwatson
#
# Description:
#  captures state of system
#
#	Usage: capture.sh [dumpOnly | emergency fileOfExceededLimits] # dumpOnly is default
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$

. $HOME/etc/setenv.sh

usage="Usage: capture.sh [dumpOnly | emergency fileOfExceededLimits] # dumpOnly is default"
type="dumpOnly"

if [ -n $1 ] ; then
	if [ "$1" = "-h" -o "$1" = "--help" ] ; then
		echo ; echo "$usage" ; echo
		exit 0
	fi
	type="$1"
fi

startDateTime=""

fileOfExceededLimits=""
if [ "$type" != "dumpOnly" ] ; then
	if [ -n $2 ] ; then
		fileOfExceededLimits="$2"
		if [ -f "$fileOfExceededLimits" ] ; then
			startDateTime=`cat $fileOfExceededLimits | awk -F "=" '$1=="monitorSTART"{print $2}'`
		else
			echo >&2 ; echo "WARNING: ExceededLimitsFile:$fileOfExceededLimits is not exists" >&2
			echo >&2 ; echo "$usage" >&2 ; echo >&2
			type="dumpOnly"
		fi
	else
		echo >&2 ; echo "WARNING: fileOfExceededLimits parameter missing" >&2
		echo >&2 ; echo "$usage" >&2 ; echo >&2
		type="dumpOnly"
	fi
fi
							
if [ "$type" = "dumpOnly" ] ; then
	$ETC/rc capture
	exit 0
fi


### --- Append capture.log

tempLogFile="$TMP/capture.$$.log.tmp"

echo >>$tempLogFile
echo "@@@ $startDateTime MONITOR" >>$tempLogFile
echo >>$tempLogFile

grep -v "^monitorSTART=" $fileOfExceededLimits >>$tempLogFile

$ETC/rc capture >>$tempLogFile

cat $tempLogFile >>$LOG/capture.log


### --- dr.Watson

grep -v "^monitorSTART=" $fileOfExceededLimits | awk -vFS="=" '{print $1" "$0}' |\
while read msgID criticalValue ; do
	$DRWATSON_HOME/addmessage.sh -t ERROR -i $msgID -l TMP "Critical State:$criticalValue"
done

rm -f $tempLogFile
