#!/bin/sh

. $HOME/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="trackIPs[$$]"

. $DICOM_VAR/pb-scp.cfg

[ -z "$AE_TITLE" ] && AE_TITLE="$DICOM_AE_TITLE"

SCU_MYAET=""
[ -n "$AE_TITLE" ] && SCU_MYAET="-aet $AE_TITLE"

TLS_OPT="+tls $SSL_SITE_KEY $SSL_SITE_CERT -ic +ps"

# means: Parent='P', Child='C', AutoForward='AFwd'
echo "select distinct ID,HOST,PORT,AE,PROTOCOL from $TARGETTBL,$DEVSERVTBL where ID=DEVICE and (TYPE='P' or TYPE='C' or SERVICE='AFwd')" | \
$MYSQL_HOME/bin/mysql -N $DBNAME | \
while read id host port ae protocol; do
  CALL=""
  [ -n "$ae" ] && CALL="--call $ae"

  FLAG_FILE=$DRWATSON_FILES/connection.down.to.$host.$port

  OPTS=""
  [ "$protocol" = "S" ] && OPTS="$TLS_OPT"

  if [ "$protocol" = "S" ] ; then
    $OPENSSL_PASS
  fi | \

  $DCMTK_HOME/bin/echoscu $OPTS $SCU_MYAET $CALL $host $port >/dev/null 2>&1
  if [ $? -ne 0 ] ; then
    if [ ! -f $FLAG_FILE ] ; then
      AETITLE=""
      [ -n "$ae" ] && AETITLE=",$ae"
      $LOGGER -p $LOG_FACILITY.err -t "$TAG" "Can't connect to $id [$host,$port$AETITLE]"
      echo "Can't connect to $id [$host,$port$AETITLE]" >> $DRWATSON_ERROR_FILE
      > $FLAG_FILE
    fi
  else
    if [ -f $FLAG_FILE ] ; then
      rm $FLAG_FILE
      $LOGGER -p $LOG_FACILITY.err -t "$TAG" "Connection to $id [$host,$port$AETITLE] OK"
      echo "Connection to $id [$host,$port$AETITLE] OK" >> $DRWATSON_READY_FILE
    fi
  fi

done
